package com.candidjava.hibernate;

import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.cfg.Configuration;
import org.hibernate.criterion.Projections;
import org.hibernate.criterion.Restrictions;
import java.util.List;

public class EmployeeDao {
	private static SessionFactory sessionFactory;

	private Session getSession() {
		Session s = null;
		try {
			sessionFactory = new Configuration().configure()
					.buildSessionFactory();
			s = sessionFactory.openSession();
		} catch (HibernateException e) {
			System.out.println(e.getMessage());
		}
		return s;
	}

	public void add(Employee emp) {
		try {
			Session s = getSession();
			Transaction transaction = s.beginTransaction();
			s.save(emp);
			transaction.commit();
		} catch (HibernateException ex) {
			ex.printStackTrace();
		}
	}

	public void getProjectionListResult() {
		try {
			Session s = getSession();
			Criteria c = s.createCriteria(Employee.class);

			c.add(Restrictions.like("name", "C%"));
			c.setProjection(Projections.projectionList()
					.add(Projections.rowCount())
					.add(Projections.groupProperty("name")));

			List<Object[]> rows = c.list();
			System.out.println("Projection List In Hibernate:");
			for (Object[] row : rows) {
				System.out.println(row[0] + " and " + row[1]);
			}
		} catch (HibernateException ex) {
			ex.printStackTrace();
		}
	}

	public void getProjectionResult() {
		try {
			Session s = getSession();

			System.out.println("Projection In Hibenate:");

			Criteria c = s.createCriteria(Employee.class);

			c.setProjection(Projections.avg("salary"));
			List avg = c.list();
			System.out.println("Average Salary :" + avg);

			c.setProjection(Projections.min("age"));
			List min = c.list();
			System.out.println("Minimum Age :" + min);

			c.setProjection(Projections.max("experience"));
			List max = c.list();
			System.out.println("Maximum Experience :" + max);

			c.setProjection(Projections.count("name"));
			List count = c.list();
			System.out.println("Employee Count :" + count);

			c.setProjection(Projections.sum("salary"));
			List sum = c.list();
			System.out.println("Sum Of Salary :" + sum);

			c.setProjection(Projections.countDistinct("name"));
			List distinct = c.list();
			System.out.println("Distinct values in Name:" + distinct);

		} catch (Exception e) {
			System.out.println(e.getMessage());
		}
	}
}